<?php
!defined('P_W') && exit('Forbidden');

define( 'ILLEGAL_USERNAME', '501' );
define( 'USERNAME_SAME', '502' );
define( 'ILLEGAL_EMAIL', '503' );
define( 'REG_EMAIL_HAVE_SAME', '504' );
define( 'REG_USERNAME_LIMIT' , '505' );
define( 'USERNAME_LIMIT', '506' );
define( 'REG_PASSWORD_MINLIMIT', '507' );
define( 'REG_PASSWORD_MAXLIMIT', '508' );
define( 'ILLEGAL_PASSWORD', '509' );
define( 'PASSWORD_CONFIRM', '510' );
define( 'REG_PASSWORD_LOWSTRING', '511' );
define( 'REG_PASSWORD_UPSTRING', '512' );
define( 'REG_PASSWORD_NUM', '513' );
define( 'REG_PASSWORD_SPECIALSTRING', '514' );
define( 'EMAIL_CHECK', '515' );
define( 'ILLEGAL_EMAIL', '516' );
define( 'EMAIL_BANCHECK' , '517' );
define( 'REG_EMAIL_HAVE_SAME', '518' );
define( 'REG_NAMETOPWD', '519' );

/**
 * ûעᡢӲ
 * fix by 119422342@qq.com
 *
 */
class RegisterApi extends BaseApi {
	
	var $db;
	var $data;
	var $memberinfo;
	var $illegalChar;
	
	var $inv = array();
	var $uid;
	
	function RegisterApi() {
		global $db;
		$this->db = & $db;
		$this->data = array(
			'username' => '',
			'password' => '',
			'email' => '',
			'safecv' => '',
			'yz' => 0,
			'groupid' => 0,
			'memberid' => 0,
			'userstatus' => 0
		);
		$this->memberinfo = array();
		$this->illegalChar = array(
			"\\",
			'&',
			' ',
			"'",
			'"',
			'/',
			'*',
			',',
			'<',
			'>',
			"\r",
			"\t",
			"\n",
			'#',
			'%',
			'?',
			''
		);
	}
	
	function setName($regname) {
		RegisterApi::checkName($regname);
		$this->data['username'] = $regname;
	}
	
	function setPwd($regpwd, $regpwdrepeat) {
		RegisterApi::checkPwd($regpwd, $regpwdrepeat);
		$this->data['password'] = md5($regpwd);
	}
	
	function setEmail($regemail) {
		RegisterApi::checkEmail($regemail);
		$this->data['email'] = $regemail;
	}
	
	function setCustomfield($customfield) {
		global $value;
		$srcValue = $value;
		if (empty($customfield) || !is_array($customfield)) return;
		
		foreach ($customfield as $key => $value) {
			$field = "field_" . (int) $value['id'];
			$v = S::escapeChar(S::getGP($field, 'P'));
			if ($value['required'] && !$v) {
				Showmsg('field_empty');
			}
			if ($value['maxlen'] && strlen($v) > $value['maxlen']) {
				Showmsg('field_lenlimit');
			}
			$v && $this->memberinfo[$field] = $v;
		}
		$value = $srcValue;
	}
	
	function setCustomdata($customdata) {
		global $db_union;
		if (!is_array($db_union)) {
			$db_union = explode("\t", stripslashes($db_union));
		}
		$custominfo = unserialize($db_union[7]);
		if ($custominfo && $customdata) {
			foreach ($customdata as $key => $val) {
				$key = S::escapeChar($key);
				$customdata[stripslashes($key)] = stripslashes($val);
			}
			$this->memberinfo['customdata'] = serialize($customdata);
		}
	}
	
	function setReason($regreason) {
		if (L::reg('rg_ifcheck')) {
			!$regreason && Showmsg('reg_reason');
			$this->memberinfo['regreason'] = $regreason;
		}
	}
	
	function setSafecv($question, $customquest, $answer) {
		global $db_ifsafecv;
		if ($db_ifsafecv) {
			require_once (R_P . 'require/checkpass.php');
			$this->data['safecv'] = questcode($question, $customquest, $answer);
		}
	}
	
	function setField($field, $value) {
		$this->data[$field] = $value;
	}
	
	function setStatus($pos, $value = '1') {
		setstatus($this->data['userstatus'], $pos, $value);
	}
	
	function execute() {
		require_once (R_P . 'uc_client/uc_client.php');
		if (($winduid = uc_user_register($this->data['username'], $this->data['password'], $this->data['email'])) < 0) {
			switch ($winduid) {
				case -1:
					printResponse( $this->errMessage( ILLEGAL_USERNAME, 'дûϷ' ) );
					return $this->errMessage( ILLEGAL_USERNAME, 'дûϷ' );
					break;
				case -2:
					printResponse( $this->errMessage( USERNAME_SAME, 'ûѾ' ) );
					break;
				case -3:
					printResponse( $this->errMessage( ILLEGAL_EMAIL, '䲻Ϸ' ) );
					break;
				case -4:
					printResponse( $this->errMessage( REG_EMAIL_HAVE_SAME, 'Ѿʹù' ) );
					break;
				default:
					$errmsg = 'undefined_action';
			}
		}
		$this->uid = $winduid;
		
		$this->_setMemberid();
		$this->_setGroupid();
		$this->_setEmailCheck();
		$this->_insertUser();

		return array(
			'errCode' => 0,
			'errMessage' => ''
		);
	}
	
	function appendUser($uid, $username, $md5_pwd, $email) {
		$this->uid = $uid;
		$this->data['username'] = $username;
		$this->data['password'] = $md5_pwd;
		$this->data['email'] = $email;
		//$this->data['safecv']	= $safecv;

		$this->_setMemberid();
		$this->_setGroupid();
		$this->_setEmailCheck();
		$this->_insertUser();
	}
	
	function changeEmail($uid,$newEmail){
		$uid = intval($uid);
		$newEmail = trim($newEmail);
		if(!$uid || !$newEmail) return false;
		PW_Register::checkEmail($newEmail);
		return pwQuery::update('pw_members' , "uid=:uid", array($uid), array('email'=>$newEmail));
	}
	
	function _insertUser() {
		global $timestamp, $onlineip, $credit;
		/**
		$pwSQL = S::sqlSingle(array(
			'uid' => $this->uid,
			'username' => $this->data['username'],
			'password' => $this->data['password'],
			'safecv' => $this->data['safecv'],
			'email' => $this->data['email'],
			'groupid' => $this->data['groupid'],
			'memberid' => $this->data['memberid'],
			'regdate' => $timestamp,
			'yz' => $this->data['yz'],
			'userstatus' => $this->data['userstatus'],
			'newpm' => 0
		));
		$this->db->update("REPLACE INTO pw_members SET $pwSQL");
		**/
		$pwSQL = array(
			'uid' => $this->uid,
			'username' => $this->data['username'],
			'password' => $this->data['password'],
			'safecv' => $this->data['safecv'],
			'email' => $this->data['email'],
			'groupid' => $this->data['groupid'],
			'memberid' => $this->data['memberid'],
			'regdate' => $timestamp,
			'yz' => $this->data['yz'],
			'userstatus' => $this->data['userstatus'],
			'newpm' => 0
		);
		pwQuery::replace('pw_members', $pwSQL);
		/**
		$pwSQL = S::sqlSingle(array(
			'uid' => $this->uid,
			'postnum' => 0,
			'lastvisit' => $timestamp,
			'thisvisit' => $timestamp,
			'onlineip' => $onlineip
		));
		$this->db->pw_update(
			'SELECT uid FROM pw_memberdata WHERE uid=' . S::sqlEscape($this->uid),
			'UPDATE pw_memberdata SET ' . $pwSQL . ' WHERE uid=' . S::sqlEscape($this->uid),
			'INSERT INTO pw_memberdata SET ' . $pwSQL
		);
		**/
		$pwSQL = array(
			'uid' => $this->uid,
			'postnum' => 0,
			'lastvisit' => $timestamp,
			'thisvisit' => $timestamp,
			'onlineip' => $onlineip
		);
		$this->db->pw_update(
			'SELECT uid FROM pw_memberdata WHERE uid=' . S::sqlEscape($this->uid),
			pwQuery::updateClause('pw_memberdata', 'uid =:uid', array($this->uid), $pwSQL),
			pwQuery::insertClause('pw_memberdata', $pwSQL)
		);
		
		//$this->db->update("REPLACE INTO pw_memberdata SET $pwSQL");

		require_once (R_P . 'require/credit.php');
		$credit->addLog('reg_register', L::reg('rg_regcredit'), array(
			'uid' => $this->uid,
			'username' => stripslashes($this->data['username']),
			'ip' => $onlineip
		));
		$credit->sets($this->uid, L::reg('rg_regcredit'), false);
		$credit->runsql();
		
		//* $this->db->update("UPDATE pw_bbsinfo SET newmember=" . S::sqlEscape($this->data['username']) . ",totalmember=totalmember+1 WHERE id='1'");
		$this->db->update(pwQuery::buildClause("UPDATE :pw_table SET newmember=:newmember,totalmember=totalmember+1 WHERE id=:id", array('pw_bbsinfo',$this->data['username'],1)));
		$this->memberinfo or $this->memberinfo['uid'] = $this->uid;
		if ($this->memberinfo) {
			/**
			$this->db->update("REPLACE INTO pw_memberinfo SET uid=" . S::sqlEscape($this->uid) . ',' . S::sqlSingle($this->memberinfo));
			**/
			$_temp = array('uid' => $this->uid) + $this->memberinfo;
			pwQuery::replace('pw_memberinfo', $_temp);
		}

		$statistics = L::loadClass('Statistics', 'datanalyse');
		$statistics->register();
	}
	
	function getRegUser() {
		return array(
			$this->uid,
			$this->data['yz'],
			$this->data['safecv']
		);
	}
	
	function _setMemberid() {
		/*
		$lneed = L::config('lneed', 'level');
		@asort($lneed);
		$this->data['memberid'] = key($lneed);
		*/
		global $db_upgrade;
		is_array($upgradeset = unserialize($db_upgrade)) || $upgradeset = array();
		$usercredit = L::reg('rg_regcredit');
		isset($usercredit['rvrc']) && $usercredit['rvrc'] *= 10;
		require_once(R_P.'require/functions.php');
		$this->data['memberid'] = getmemberid(CalculateCredit($usercredit, $upgradeset));
	}
	
	function _setGroupid() {
		if ($this->data['groupid'] == 0) {
			$this->data['groupid'] = L::reg('rg_ifcheck') ? 7 : -1;
		}
	}
	
	function _setEmailCheck() {
		if ($this->data['yz'] == 0) {
			$this->data['yz'] = L::reg('rg_emailcheck') ? num_rand(9) : 1;
		}
	}
	
	function checkInv($invcode) {
		global $timestamp;
		if (empty($invcode)) {
			Showmsg('invcode_empty');
		}
		$inv_days = L::config('inv_days', 'inv_config') * 86400;
		$this->inv = $this->db->get_one("SELECT id,uid FROM pw_invitecode WHERE invcode=" . S::sqlEscape($invcode) . " AND ifused<'1' AND createtime>" . S::sqlEscape($timestamp - $inv_days));
		!$this->inv && Showmsg('illegal_invcode');
	}
	
	function disposeInv() {
		global $timestamp;
		$this->db->update("UPDATE pw_invitecode SET " . S::sqlSingle(array(
			'receiver' => $this->data['username'],
			'usetime' => $timestamp,
			'ifused' => 1
		)) . ' WHERE id=' . S::sqlEscape($this->inv['id']));
		if ($this->inv['uid'] == 0) {
			$this->db->update("UPDATE pw_clientorder SET uid=" . S::sqlEscape($this->uid) . " WHERE type='4' AND uid='0' AND paycredit=" . S::sqlEscape($this->inv['id']));
		}
	}
	
	/**
	 * @static
	 */
	function checkName($regname) {
		if (!RegisterApi::checkNameLen(strlen($regname))) {
			printResponse( $this->errMessage( REG_USERNAME_LIMIT, 'ûȲȷ' ) );
		}
		if (str_replace($this->illegalChar, '', $regname) != $regname) {
			printResponse( $this->errMessage( ILLEGAL_USERNAME, 'дûϷ' ) );
		}
		if (!L::reg('rg_rglower') && !RegisterApi::checkRglower($regname)) {
			printResponse( $this->errMessage( USERNAME_LIMIT, 'ûкַ' ) );
		}
		if (S::inArray(strtolower($regname), array(
			'guest',
			'system'
		))) {
			printResponse( $this->errMessage( ILLEGAL_USERNAME, 'дûϷ' ) );
		}
		$banname = explode(',', L::reg('rg_banname'));
		foreach ($banname as $key => $value) {
			if ($value !== '' && strpos($regname, $value) !== false) {
				printResponse( $this->errMessage( ILLEGAL_USERNAME, 'дûϷ' ) );
			}
		}
		require_once (R_P . 'require/functions.php');
		if ($regname !== Sql_cv($regname)) {
			printResponse( $this->errMessage( ILLEGAL_USERNAME, 'дûϷ' ) );
		}
	}
	
	/**
	 * @static
	 */
	function checkNameLen($len) {
		list($regminname, $regmaxname) = explode("\t", L::reg('rg_namelen'));
		return ($len >= $regminname && $len <= $regmaxname);
	}
	
	/**
	 * @static
	 */
	function checkPwd($regpwd, $regpwdrepeat) {
		list($regminpwd, $regmaxpwd) = explode("\t", L::reg('rg_pwdlen'));
		if (strlen($regpwd) < $regminpwd) {
			printResponse( $this->errMessage( REG_PASSWORD_MINLIMIT , getLangInfo( 'msg', 'reg_password_minlimit')  ) );
		} elseif ($regmaxpwd && strlen($regpwd) > $regmaxpwd) {
			printResponse( $this->errMessage( REG_PASSWORD_MAXLIMIT , getLangInfo('msg', 'reg_password_maxlimit') ) );
		}
		if (str_replace($this->illegalChar, '', $regpwd) != $regpwd) {
			printResponse( $this->errMessage( ILLEGAL_PASSWORD, getLangInfo('msg', 'illegal_password') ) );
		}
		if ($regpwd != $regpwdrepeat) {
			printResponse( $this->errMessage('PASSWORD_CONFIRM', getLangInfo('msg', 'password_confirm')) );
		}
		$this->checkPwdComplex($regpwd);
	}
	
	/**
	 * @static
	 */
	function checkPwdComplex($regpwd) {
		if (!L::reg('rg_pwdcomplex')) return;
		foreach (explode(',', L::reg('rg_pwdcomplex')) as $key => $value) {
			switch (intval($value)) {
				case 1:
					if (!preg_match('/[a-z]/', $regpwd)) {
						printResponse( $this->errMessage( REG_PASSWORD_LOWSTRING, getLangInfo('msg', 'reg_password_lowstring') ) );
					}
					break;
				case 2:
					if (!preg_match('/[A-Z]/', $regpwd)) {
						printResponse( $this->errMessage( REG_PASSWORD_UPSTRING, getLangInfo('msg', 'reg_password_upstring') ) );
					}
					break;
				case 3:
					if (!preg_match('/[0-9]/', $regpwd)) {
						printResponse( $this->errMessage( REG_PASSWORD_NUM, getLangInfo('msg', 'reg_password_num') ) );
					}
					break;
				case 4:
					if (!preg_match('/[^a-zA-Z0-9]/', $regpwd)) {
						printResponse( $this->errMessage( REG_PASSWORD_SPECIALSTRING, getLangInfo('msg', 'reg_password_specialstring') ) );
					}
					break;
			}
		}
	}
	
	/**
	 * @static
	 */
	function checkSameNP($regpwd, $regname) {
		if (L::reg('rg_npdifferf') && $regpwd == $regname) {
			printResponse( $this->errMessage( REG_NAMETOPWD, getLangInfo('msg', 'reg_nameuptopwd')) );
            //Showmsg('reg_nameuptopwd');
		}
	}
	
	/**
	 * @static
	 */
	function checkEmail($regemail) {
		if (empty($regemail) || !ereg("^[-a-zA-Z0-9_\.]+\@([0-9A-Za-z][0-9A-Za-z-]+\.)+[A-Za-z]{2,5}$", $regemail)) {
			printResponse( $this->errMessage(ILLEGAL_EMAIL, getLangInfo('msg','illegal_email')) );
		}
		if (L::reg('rg_emailtype') == 1 && L::reg('rg_email')) {
			
			$e_check = 0;
			$e_limit = explode(',', L::reg('rg_email'));
			foreach ($e_limit as $key => $val) {
				if (strpos($regemail, "@" . $val) !== false) {
					$e_check = 1;
					break;
				}
			}
			$e_check == 0 && printResponse( $this->errMessage(EMAIL_CHECK, getLangInfo('msg','email_check')) );
		} elseif (L::reg('rg_emailtype') == 2 && L::reg('rg_banemail')) {
			$e_check = 0;
			$e_limit = explode(',', L::reg('rg_banemail'));
			foreach ($e_limit as $key => $val) {
				if (strpos($regemail, "@" . $val) !== false) {
					$e_check = 1;
					break;
				}
			}
			$e_check == 1 && printResponse( $this->errMessage(EMAIL_BANCHECK, getLangInfo('msg','email_bancheck')) );
		}
		$email_check = $this->db->get_one('SELECT COUNT(*) AS count FROM pw_members WHERE email=' . S::sqlEscape($regemail));
		if ($email_check['count']) {
			printResponse( $this->errMessage(REG_EMAIL_HAVE_SAME, getLangInfo('msg','reg_email_have_same')) );
		}
	}
	
	/**
	 * @static
	 */
	function checkRglower($username) {
		global $db_charset;
		
		$namelen = strlen($username);
		for ($i = 0; $i < $namelen; $i++) {
			if (ord($username[$i]) > 127) {
				$i += 'utf-8' != $db_charset ? 1 : 2;
			} else {
				if (ord($username[$i]) >= 65 && ord($username[$i]) <= 90) {
					return false;
				}
			}
		}
		return true;
	}
}
?>