<?php
/**
 * User: leeyifiei
 * Date: 17/1/5
 */

require_once(R_P . 'lib/forum/posttopic.class.php');

class postTopicExt extends postTopic
{

    public $topic_uploaded = array();

    public function __construct($post)
    {
        parent::postTopic($post);
    }

    function postCheck()
    {
        global $groupid, $winddb;

        if ($winddb['groups']) {
            $groupids = explode(',', substr($winddb['groups'], 1, -1));
            foreach ($groupids as $value) {
                if (strpos($this->forum->foruminfo['allowpost'], ",$value,") !== false) {
                    $ifgroups = true;
                }
            }
        }

        if ($this->forum->foruminfo['allowpost'] && strpos($this->forum->foruminfo['allowpost'], ',' . $groupid . ',') === false && !$ifgroups && !$this->post->admincheck) {
            Showmsg('postnew_group_right');
        }
    }

    /**
     * ʼϢ
     */
    function initData()
    {
        global $timestamp, $db_topicname, $db_charset;
        $topic_json = S::getGP('typeoption', 'P');

        if (strtolower($db_charset) == 'gbk') {
            $topic_json = mb_convert_encoding($topic_json, 'UTF-8', 'GBK');
        }

        $topic_json = stripslashes($topic_json);
        require_once(R_P . 'clientapi/library/CJSON.php');

        $typeoption = CJSON::decode($topic_json);

        $topic = array();
        if (!empty($typeoption)) {
            foreach ($typeoption as $key => $option) {
                if (strtolower($db_charset) == 'gbk' && is_string($option['select'])) {
                    $option['select'] = mb_convert_encoding($option['select'], 'GBK', 'UTF-8');
                }
                if ($option['type'] == 'image') {
                    $topic[$option['kindid']] = $option['image']['url'];
                } else {
                    $topic[$option['kindid']] = $option['select'];
                }
            }
        }

        $query = $this->db->query("SELECT fieldid,name,type,rules,ifmust,ifable FROM pw_topicfield WHERE modelid=" . S::sqlEscape($this->modelid));
        while ($rt = $this->db->fetch_array($query)) {
            if ($rt['type'] != 'upload' && $rt['ifable'] && $rt['ifmust'] && !S::isNatualValue($topic[$rt['fieldid']])) {
                $db_topicname = $rt['name'];
                showResult(1, getLangInfo('msg', 'topic_field_must'));
            }
            if (S::isNatualValue($topic[$rt['fieldid']])) {
                if ($rt['type'] == 'number') {
                    !is_numeric($topic[$rt['fieldid']]) && showResult(1, getLangInfo('msg', 'number_error'));
                    $limitnum = unserialize($rt['rules']);
                    if (($limitnum['minnum'] !== '' && $topic[$rt['fieldid']] < $limitnum['minnum']) || ($limitnum['maxnum'] !== '' && $topic[$rt['fieldid']] > $limitnum['maxnum'])) {
                        $db_topicname = $rt['name'];
                        showResult(1, getLangInfo('msg', 'topic_number_limit'));
                    }
                } elseif ($rt['type'] == 'range') {
                    !is_numeric($topic[$rt['fieldid']]) && showResult(1, getLangInfo('msg', 'number_error'));
                } elseif ($rt['type'] == 'email') {
                    if (!preg_match("/^[-a-zA-Z0-9_\.]+@([0-9A-Za-z][0-9A-Za-z-]+\.)+[A-Za-z]{2,5}$/", $topic[$rt['fieldid']])) {
                        showResult(1, getLangInfo('msg', 'illegal_email'));
                    }
                } elseif ($rt['type'] == 'checkbox') {
                    if( !is_array($topic[$rt['fieldid']]) ) {
                        $topic[$rt['fieldid']] = explode(',', $topic[$rt['fieldid']]);
                    }
                    $checkboxs = ',';
                    foreach ($topic[$rt['fieldid']] as $value) {
                        $checkboxs .= $value . ',';
                    }
                    $topic[$rt['fieldid']] = $checkboxs;
                } elseif ($rt['type'] == 'calendar') {
                    $topic[$rt['fieldid']] = PwStrtoTime($topic[$rt['fieldid']]);
                } elseif ($rt['type'] == 'upload') {
                    $this->topic_uploaded = array(
                        $rt['fieldid'] => $topic[$rt['fieldid']],
                    );
                    unset($topic[$rt['fieldid']]);
                }
            }
        }
        $this->data['topic'] = serialize($topic);
    }

    /**
     * ݿ
     * @param $tid
     * @param $fid
     */
    function insertData($tid, $fid)
    {
        global $winduid;

        $this->data['tid'] = $tid;
        $this->data['fid'] = $fid;
        $topicdb = unserialize($this->data['topic']);
        unset($this->data['topic']);
        foreach ($topicdb as $key => $value) {
            $this->data['field' . $key] = $value;
        }
        $tablename = GetTopcitable($this->modelid);

        $this->db->pw_update(
            "SELECT tid FROM $tablename WHERE tid=" . S::sqlEscape($tid),
            "UPDATE $tablename SET " . S::sqlSingle($this->data) . "WHERE tid=" . S::sqlEscape($tid),
            "INSERT INTO $tablename SET " . S::sqlSingle($this->data)
        );

        /*ϴ*/
        if (!empty($this->topic_uploaded)) {
            require_once(R_P . 'clientapi/library/pcupload.class.php');
            foreach ($this->topic_uploaded as $key => $val) {
                $upload_bhv = new PcUpload($tid, $this->modelid);
                $upload_bhv->attach_id = $key;
                $upload_bhv->attach_name = 'topic';
                qfupload($val, $fid, $winduid, $upload_bhv, 'topic');
            }
        }
    }

    // ȡϢ
    function getTopicvalue($modelid,$pcdb = array()) {/*ʾ*/
        global $tid;
        $newtopicvalue = $topicvalue = $flashtopicvalue = '';

        $newtopicvalue .= "<div class=\"typeoption\"><table summary=\"threadsort\" cellpadding=\"0\" cellspacing=\"0\" class=\"cgtl\">";
        if(!isset($this->topicmodeldb[$modelid])) return;

        if (isset($pcdb) && count($pcdb) > 0) {
            $fieldone = $pcdb;
        } else {
            $tablename = GetTopcitable($modelid);
            $fieldone = $this->db->get_one("SELECT * FROM $tablename WHERE tid=".S::sqlEscape($tid));
        }

        $query = $this->db->query("SELECT fieldid,fieldname,name,rules,type,vieworder,descrip FROM pw_topicfield WHERE modelid=".S::sqlEscape($modelid)." AND ifable = 1 ORDER BY vieworder,fieldid");

        $vieworder_mark = $i = $tmpCount = 0;
        $flash = false;
        while ($rt = $this->db->fetch_array($query)) {
            if (!$fieldone[$rt['fieldname']]) continue;
            if (($rt['type'] == 'img' || $rt['type'] == 'upload') && $fieldone[$rt['fieldname']]) {
                $tmpCount++;
                $rt['type'] == 'upload' && $fieldone[$rt['fieldname']] = postTopic::getpcurl($fieldone[$rt['fieldname']],1);
                $flashtopicvalue .= "<tr><th>$rt[name]</th><td><img src=\"{$fieldone[$rt[fieldname]]}\" /></td></tr>";
                $flash = true;
            }
            if($rt['type'] == 'textarea') {
                $fieldone[$rt['fieldname']] = nl2br($fieldone[$rt['fieldname']]);
            }
            $rt['fieldvalue'] = $fieldone[$rt['fieldname']];
            if (S::isNatualValue($rt['fieldvalue']) && $rt['type'] != 'img' && $rt['type'] != 'upload'){
                $classname =  $i%2 == 0 ? 'two' : '';
                $rt['rules'] && $rt['rules'] = unserialize($rt['rules']);
                list($rt['name1'],$rt['name2']) = explode('{#}',$rt['name']);
                $rt['descrip'] = $rt['descrip'] ? '('.$rt['descrip'].')' : '';
                if ($rt['vieworder'] != $vieworder_mark && $vieworder_mark != 0) $topicvalue .= "</td></tr>";
                if ($rt['vieworder'] == 0) {
                    $topicvalue .= "<tr><th>$rt[name1]</th><td>";
                    $topicvalue .= $this->getFieldValueHTML($rt['type'],$rt['fieldvalue'],$rt['rules']);
                    $topicvalue .=  $rt['name2']." $rt[descrip]</td></tr>";
                    $i++;
                } else {
                    if($vieworder_mark != $rt['vieworder']) {
                        $topicvalue .= "<tr><th>$rt[name1]</th><td>";
                        $topicvalue .=  $this->getFieldValueHTML($rt['type'],$rt['fieldvalue'],$rt['rules']);
                        $topicvalue .= "$rt[name2]";
                        $i++;
                    } else {
                        $topicvalue .= "$rt[name1]";
                        $topicvalue .=  $this->getFieldValueHTML($rt['type'],$rt['fieldvalue'],$rt['rules']);
                        $topicvalue .= "$rt[name2]";
                    }
                }
                $vieworder_mark = $rt['vieworder'];
            }
        }
        $vieworder_mark !=0 && $topicvalue .= " $rt[descrip]</td></tr>";

        $flash == false && $flashtopicvalue = '';
        $newtopicvalue .= $topicvalue.$flashtopicvalue;
        $newtopicvalue .= "</table></div>";

        return $newtopicvalue;
    }

    function getFieldValueHTML($type,$fieldvalue,$rules){
        $topicvalue = '';
        if ($type == 'radio') {
            $newradio = array();
            foreach($rules as $rk => $rv){
                $rv_value = substr($rv,0,strpos($rv,'='));
                $rv_name = substr($rv,strpos($rv,'=')+1);
                $newradio[$rv_value] = $rv_name;
            }
            $topicvalue .= "{$newradio[$fieldvalue]}";

        } elseif ($type == 'checkbox') {
            $newcheckbox = array();
            foreach($rules as $ck => $cv){
                $cv_value = substr($cv,0,strpos($cv,'='));
                $cv_name = substr($cv,strpos($cv,'=')+1);
                $newcheckbox[$cv_value] = $cv_name;
            }
            $topicvalues = '';
            foreach (explode(",",$fieldvalue) as $value) {
                if (S::isNatualValue($value)) {
                    $topicvalues .= $topicvalues ? ",".$newcheckbox[$value] : $newcheckbox[$value];
                }
            }
            $topicvalue .= $topicvalues;

        } elseif ($type == 'select') {
            $newselect = array();
            foreach($rules as $sk => $sv){
                $sv_value = substr($sv,0,strpos($sv,'='));
                $sv_name = substr($sv,strpos($sv,'=')+1);
                $newselect[$sv_value] = $sv_name;
            }
            $topicvalue .= "{$newselect[$fieldvalue]}";
        } elseif ($type == 'url') {
            $topicvalue .= "<a href=\"$fieldvalue\" target=\"_blank\">$fieldvalue</a>";
        } /*elseif ($type == 'img') {
			$topicvalue .= "<img src=\"$fieldvalue\">";
		}*/ elseif ($type == 'calendar') {
            $topicvalue .= get_date($fieldvalue,'Y-n-j');
        } else {
            $topicvalue .= "$fieldvalue";
        }

        return $topicvalue;

    }

}
